/***************************************************************************
 *   Copyright (C) 2009 by Helge Kortendieck  alan@kasmithee.de            *
 *   exiftool.cpp  -  collect exif information from exiftool               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/
#include "exiftool.h"

Exiftool::Exiftool( QObject* parent )
		: QObject( parent )
{
/*	bCanon = false;			// canon maker note object not yet created
	eig = new Exifimg();
	connect( this, SIGNAL( sigEigGetExif( const ExifInf& ) ), eig, SLOT( eigPrep( const ExifInf& ) ) );
	connect( eig, SIGNAL( sigEigSendExif( const ExifInf& ) ), this, SLOT( exifImgReturn( const ExifInf& ) ) );*/
}

Exiftool::~Exiftool()
{
}


void Exiftool::procPrep( const QString& sD )	// prepare getting exif info from exiftool, receive full path and name
{
	eieClear();
	eiE.name = sD;
	slArgs.clear();
	slArgs << sD;
	sStdOut = "";
	procRun();
}

void Exiftool::procRun()						// start qprocess to get exif info
{
//  cout << "debug gtv procRun: sProg " << sProg.toStdString() << endl;                                               // *****  debug  *****
	proc = new QProcess( this );
	connect( proc, SIGNAL( finished( int, QProcess::ExitStatus ) ), this, SLOT( procEnd( int, QProcess::ExitStatus ) ) );
	connect( proc, SIGNAL( readyReadStandardOutput() ), this, SLOT( procStdOut() ) );
//    connect( mnt, SIGNAL(readyReadStandardError()), this, SLOT(procStdErr()) );
//  bProc = true;
	proc->start( "exiftool", slArgs );
}

void Exiftool::procStdOut()						// read qprocess stdout
{
	aOutput = proc->readAllStandardOutput();		// read byte array
	if ( !aOutput.isEmpty() ) {
		sStdOut += QString( aOutput ).trimmed();
//	cout << "procStdOut: sIn: " << sIn.toStdString() << endl;                                               // *****  debug  *****
	}
}

/*
void Xine::procStdErr()                    // read qprocess stderr
{
  aOutput = mnt->readAllStandardOutput();       // read byte array
  if ( !aOutput.isEmpty() ) {
    sIn = QString( aOutput ).trimmed();
  cout << "procStdErr: sIn: " << sIn.toStdString() << endl;                                               // *****  debug  *****
  }
}
*/

void Exiftool::procKill()					// kill qprocess
{
	proc->deleteLater();
}

void Exiftool::procEnd( int iD, QProcess::ExitStatus iD2 )	// qprocess ended
{
	eval();
//  cout << "debug Xine procEnd: reached ! " << endl;                                               // *****  debug  *****
}

void Exiftool::eval()						// evaluate exiftool output
{
	slStdOut = sStdOut.split( "\n" );
	if( slStdOut.size() > 0 ) {
		for( i = 0; i < slStdOut.size(); ++i) {
			sD = slStdOut.at( i );
			iD = sD.indexOf( ":" );
			sDe = sD.left( iD ).trimmed();
			sVa = sD.remove(0, iD + 1 ).trimmed();

			if( sDe == "File Type" ) {
				eiE.type = sVa;
			} else if( sDe == "Color Space" ) {
				eiE.colorSpace = sVa;
			} else if( sDe == "Bits Per Sample" ) {
				eiE.colorBits = sVa;
			} else if( sDe == "Color Components" ) {
				eiE.colorComp = sVa;
			} else if( sDe == "Orientation" ) {
				eiE.orient = sVa;
			} else if( sDe == "Create Date" ) {
				eiE.dateTime = sVa;
			} else if( sDe == "Date/Time Original" ) {
				eiE.dateTimeOrig = sVa;
			} else if( sDe == "Exposure Time" ) {
				eiE.expoTime = sVa;
			} else if( sDe == "F Number" ) {
				eiE.aperture = sVa;
			} else if( sDe == "Focal Length" ) {
				eiE.focalLen = sVa;
			} else if( sDe == "ISO" ) {
				eiE.ISO = sVa;
			} else if( sDe == "White Balance" ) {
				eiE.wb = sVa;
			} else if( sDe == "Flash" ) {
				eiE.flash = sVa;
			} else if( sDe == "Exposure Program" ) {
				eiE.expoProg = sVa;
			} else if( sDe == "Metering Mode" ) {
				eiE.meterMode = sVa;
			} else if( sDe == "Exposure Compensation" ) {
				eiE.expoComp = sVa;
			} else if( sDe == "Exposure Mode" ) {
				eiE.expoMode = sVa;
			} else if( sDe == "Auto Exposure Bracketing" ) {
				eiE.AEB = sVa;
			} else if( sDe == "AEB Bracket Value" ) {
				eiE.AEBValue = sVa;
			} else if( sDe == "AEB Sequence" ) {
				eiE.AEBSequence = sVa;
			} else if( sDe == "Bracket Shot Number" ) {
				eiE.AEBShotNum = sVa;
			} else if( sDe == "Focus Mode" ) {
				eiE.focusMode = sVa;
			} else if( sDe == "AF Mode" ) {
				eiE.AFMode = sVa;
			} else if( sDe == "Num AF Points" ) {
				eiE.AFPointNum = sVa;
			} else if( sDe == "AF Points Selected" ) {
				eiE.AFPointSel = sVa;
			} else if( sDe == "Faces Detected" ) {
				eiE.faceDetect = sVa;
			} else if( sDe == "Make" ) {
				eiE.make = sVa;
			} else if( sDe == "Camera Model Name" ) {
				eiE.model = sVa;
			} else if( sDe == "Scale Factor To 35 mm Equivalent" ) {
				eiE.crop = sVa;
			} else if( sDe == "Firmware Version" ) {
				eiE.fw = sVa;
			} else if( sDe == "Camera Body No." ) {
				eiE.serial = sVa;
			} else if( sDe == "Exif Version" ) {
				eiE.exifVer = sVa;
			} else if( sDe == "Owner Name" ) {
				eiE.owner = sVa;
			} else if( sDe == "Lens Make" ) {				// valid? estimated...
				eiE.lensMake = sVa;
			} else if( sDe == "Lens Type" ) {
				eiE.lensModel = sVa;
			} else if( sDe == "Internal Serial Number" ) {
				eiE.lensSerial = sVa;
			} else if( sDe == "Lens" ) {
				eiE.lensFocalLen = sVa;
			} else if( sDe == "Highlight Tone Priority" ) {
				eiE.dynRanEnh = sVa;
			} else if( sDe == "High ISO Noise Reduction" ) {
				eiE.nrHighISO = sVa;
			} else if( sDe == "Long Exposure Noise Reduction" ) {
				eiE.nrLongExpo = sVa;
			} else if( sDe == "Picture Style" ) {
				eiE.picMode = sVa;
			} else if( sDe == "Easy Mode" ) {
				eiE.easyMode = sVa;
			} else if( sDe == "Contrast" ) {
				eiE.contrast = sVa;
			} else if( sDe == "Saturation" ) {
				eiE.saturation = sVa;
			} else if( sDe == "Sharpness" ) {				// balid? estimated...
				eiE.sharpness = sVa;
			} else if( sDe == "Digital Gain" ) {
				eiE.gain = sVa;
			} else if( sDe == "Quality" ) {
				eiE.imgQuality = sVa;
			} else if( sDe == "Image Size" ) {
				eiE.imgSize = sVa;
			} else if( sDe == "Flash Bits" ) {				// valid? estimated...
				eiE.flashMode = sVa;
			} else if( sDe == "Red Eye Mode" ) {
				eiE.flashRedEye = sVa;
			} else if( sDe == "flashReturn" ) {
				eiE.flashReturn = sVa;
			} else if( sDe == "Flash Output" ) {
				eiE.flashDetails = sVa;
			} else if( sDe == "Camera ISO" ) {
				eiE.camISO = sVa;
			} else if( sDe == "Macro Mode" ) {				// valid?
				eiE.macroMode = sVa;
			} else if( sDe == "Drive Mode" ) {
				eiE.driveMode = sVa;
			} else if( sDe == "Spot Metering Mode" ) {
				eiE.spotMode = sVa;
			} else if( sDe == "Image Stabilization" ) {
				eiE.imgStabi = sVa;
			} else if( sDe == "Digital Zoom Ratio" ) {
				eiE.digiZoom = sVa;
			} else if( sDe == "Mirror Lockup" ) {			// valid?
				eiE.mirrorLockup = sVa;
			} else if( sDe == "Shutter Curtain Sync" ) {
				eiE.shutCurtSync = sVa;
			} else if( sDe == "Self Timer" ) {
				eiE.selftimer = sVa;
			} else if( sDe == "Author" ) {					// valid?
				eiE.author = sVa;
			} else if( sDe == "Copyright" ) {				// valid?
				eiE.copyright = sVa;
			} else if( sDe == "User Comment" ) {
				eiE.comment = sVa;
			} else if( sDe == "Description" ) {				// valid?
				eiE.description = sVa;
			}
		}
		eiE.lensAperture = sAperMax + " - " + sAperMin;
	} else {									// no exif info found                                    CHECKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK
		
	}

	emit sigEtDone( eiE );
//  cout << "debug Xine procEnd: reached ! " << endl;                                               // *****  debug  *****
}


void Exiftool::eieClear()					// clear eiE struct - any better solution ?
{
	eiE.name="";			// image		- image name, full absolute path and name
	eiE.size="";			// 				- image size, x.xx MB
	eiE.type="";			// 				- image type
	eiE.colorSpace="";		// color info	- image color space; e. g. sRGB
	eiE.colorBits="";		//				- color bits
	eiE.colorComp="";		//				- color components
	eiE.exifInfo="";		// exif info status text: not found, found, errors
	eiE.origX="";			// size			- original image width
	eiE.origY="";			// 				- origianl image height
	eiE.orient="";			// image orientation when shot
	eiE.dateTime="";		// date n time	- image date and time
	eiE.dateTimeOrig="";	//				- original date and time when shot
	eiE.expoTime="";		// key values	- exposure time or shutter speed
	eiE.aperture="";		// 				- aperture or f-number
	eiE.focalLen="";		// 				- focal length
	eiE.ISO="";				//				- ISO setting
	eiE.wb="";				//				- whitebalance
	eiE.flash="";			//				- flash fired or not
	eiE.expoProg="";		// exposure		- exposure program or camera program mode =""; e.g.: auto, P, Av, Tv, Adepth, Easy Modes...
	eiE.meterMode="";		// 				- metering mode =""; e.g.: average, centerweightedaverage, spot...
	eiE.expoComp="";		// 				- exposure compensation
	eiE.expoMode="";		// 				- exposure mode =""; e.g.: auto, manual, bracketting...
	eiE.AEB="";				// 				- auto exposure bracketing
	eiE.AEBValue="";		// 				- auto exposure bracketing value
	eiE.AEBSequence="";		// 				- auto exposure bracketing sequence; e. g. 0,-,+
	eiE.AEBShotNum="";		// 				- AEB shot number
	eiE.focusMode="";		// focus		- focus mode, e.g.: one-shot AF, AI Servo AF, AI Focus AF...
	eiE.AFMode="";			//				- AF mode; e. g. single point AF
	eiE.AFPointNum="";		// 				- number AF points
	eiE.AFPointSel="";		//				- AF points selected
	eiE.faceDetect="";		// 				- face detected
	eiE.make="";			// camera		- camera make
	eiE.model="";			// 				- camera model
	eiE.modelID="";			//				- camera model ID
	eiE.crop="";			//				- camera sensor crop factor
	eiE.fw="";				//				- camera firmware
	eiE.serial="";			//				- camera serial number
	eiE.exifVer="";			//				- exif version
	eiE.owner="";			//				- camera owner
	eiE.lensMake="";		// lens			- lens make
	eiE.lensModel="";		//				- lens model
	eiE.lensSerial="";		//				- lens serial
	eiE.lensFocalLen="";	//				- lens focal length or range (zoom)
	eiE.lensAperture="";	//				- lens aperture or aperture range
	eiE.dynRanEnh="";		// sensor tweaks- dynamic range enhancement or highlight tone priority
	eiE.nrHighISO="";		// 				- high ISO noise reduction
	eiE.nrLongExpo="";		//				- long exposure noise reduction
	eiE.picMode="";			// jpeg engine	- picture mode/style
	eiE.easyMode="";		// 				- easy mode details
	eiE.contrast="";		// 				- contrast
	eiE.saturation="";		//				- saturation
	eiE.sharpness="";		//				- sharpness
	eiE.gain="";			//				- gain control
	eiE.imgQuality="";		//				- image quality
	eiE.imgSize="";			//				- image size
	eiE.flashMode="";		// flash		- flash mode
	eiE.flashRedEye="";		//				- flash red eye reduction
	eiE.flashReturn="";		//				- flash strobe return
	eiE.flashDetails="";	//				- flash details
	eiE.camISO="";			// more cam set - camera ISO setting
	eiE.macroMode="";		//				- macro mode
	eiE.driveMode="";		//				- drive mode
	eiE.spotMode="";		//				- spot meter mode
	eiE.imgStabi="";		//				- image stabilization
	eiE.digiZoom="";		//				- digital zoom factor
	eiE.mirrorLockup="";	//				- mirror lockup
	eiE.shutCurtSync="";	//				- shutter curtain synchronization
	eiE.selftimer="";		//				- selftimer
	eiE.author="";			// image		- author
	eiE.copyright="";		//				- copyright notice
	eiE.comment="";			//				- user comment
	eiE.description="";		//				- image description
	sAperMax = "";
	sAperMin = "";
}


//#include "exiftool.moc"
