/***************************************************************************
 *   Copyright (C) 2009 by Helge Kortendieck  alan@kasmithee.de            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/

#ifndef _EXIFTOOL_H_
#define _EXIFTOOL_H_

#include <QObject>
#include <QProcess>
#include <QString>
#include <QStringList>

#include "structs.h"

#include <iostream>
using namespace std;


class Exiftool : public QObject
{
	Q_OBJECT

public:
	Exiftool( QObject* parent = 0 );
		~Exiftool();
    /*$PUBLIC_FUNCTIONS$*/

public slots:
    /*$PUBLIC_SLOTS$*/

	signals:

protected:
    /*$PROTECTED_FUNCTIONS$*/

protected slots:
    /*$PROTECTED_SLOTS$*/

private:
//	bool bProc;

	int i;
	int iD;
//	int iD2;

	QByteArray aOutput;   // qprocess output, stdout or stderr

	QProcess *proc;             // qprocess using gtv to record satellite channel

	QString sAperMax;		// 2.8
	QString sAperMin;		// 23
	QString sD;
	QString sDe;				// exiftool per line: description
//	QString sImCur;			// image to show, full path and name
	QString sStdOut;
	QString sVa;				// exiftool per line: value

//	QString sFile;
//	QString sProg;
//  QString sIn;          // incomming, here process output

	QStringList slArgs;		// list with arguments for qprocess
	QStringList slStdOut;

	ExifInf eiD;			// exif info struct (dummy) entity
	ExifInf eiE;			// exif info struct entity

private slots:
	void eieClear();									// clear eiE struct - any better solution ?

	void eval();										// evaluate exiftool output

	void procPrep( const QString& sD );					// check if xine is installed
	void procRun();										// start qprocess with xine showing the current recording
	void procStdOut();									// read qprocess stdout
//	void procStdErr();									// read qprocess stderr
	void procKill();									// kill qprocess
	void procEnd( int iD, QProcess::ExitStatus iD2 );	// qprocess ended

//	void setRead();

	signals:
		void sigEtDone( const ExifInf& eiE );			// submit exif info from exiftool
};

#endif
