/***************************************************************************
 *   Copyright (C) 2009 Helge Kortendieck  <alan@kasmithee.de>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef _STRUCTS_H_
#define _STRUCTS_H_

#include <QString>

struct ExifInf {
	// main
	QString name;			// image	name, full absolute path and name
	QString size;			//			size, x.xx MB
	QString type;			//			type
	QString colorSpace;		//			color space; e. g. sRGB
	QString colorBits;		//			color bits
	QString colorComp;		//			color components
	QString origX;			//			original image width
	QString origY;			//			origianl image height
	QString orient;			//			image orientation when shot
	QString dateTime;		//			image date and time
	QString dateTimeOrig;	//			original date and time when shot
	QString exifInfo;		//			exif info status text: not found, found, errors

	QString expoTime;		// key values	exposure time or shutter speed
	QString aperture;		//			aperture or f-number
	QString focalLen;		//			focal length
	QString ISO;			//			ISO setting
	QString wb;				//			whitebalance
	QString flash;			//			fired or not

	QString expoProg;		// exposure program or camera program mode ; e.g.: auto, P, Av, Tv, Adepth, Easy Modes...
	QString expoComp;		//			compensation, AEBBase +/- AEBValue for bracketing mode
	QString meterMode;		//			metering mode ; e.g.: average, centerweightedaverage, spot...
	QString focusMode;		//			focus mode ; e.g.: one-shot AF, AI Servo AF, AI Focus AF...
	QString AFMode;			//			AF mode; e. g. single point AF

	QString make;			// camera	make
	QString model;			//			model
	QString lensMake;		// lens		make
	QString lensModel;		//			model
	QString lensFocalLen;	//			focal length or range (zoom)


	// more
	QString dynRanEnh;		// sensor	- dynamic range enhancement or highlight tone priority
	QString nrHighISO;		//			- high ISO noise reduction
	QString nrLongExpo;		//			- long exposure noise reduction
	QString crop;			//			- camera sensor crop factor

	QString imgQuality;		// jpeg engine 	- image quality
	QString imgSize;		//				- image size
	QString picMode;		//				- picture mode/style
	QString easyMode;		//				- easy mode details
	QString contrast;		//				- contrast
	QString saturation;		//				- saturation
	QString sharpness;		//				- sharpness
	QString gain;			//				- gain control

	QString flashMode;		// flash	- mode
	QString flashRedEye;	//			- red eye reduction
	QString flashReturn;	//			- strobe return
	QString flashDetails;	//			- details

	QString macroMode;		// macro mode
	QString driveMode;		// drive mode
	//??
	QString spotMode;		// spot meter mode
	QString digiZoom;		// digital zoom factor
	QString mirrorLockup;	// mirror lockup
	QString shutCurtSync;	// shutter curtain synchronization
	QString selftimer;		// selftimer
	QString AEB;			// AEB	- auto exposure bracketing on/off
	QString AEBSequence;	//		- sequence; e. g. 0,-,+
	QString AEBShotNum;		//		- shot number


	// ID
	QString modelID;		// camera	- model ID
	QString fw;				//			- firmware
	QString serial;			//			- serial number
	QString exifVer;		//			- exif version
	QString lensSerial;		// lens serial

	QString owner;			// camera owner
	QString author;			// author
	QString copyright;		// copyright notice
	QString comment;		// user comment
	QString description;	// image description


	// unused
	QString expoMode;		// exposure mode ; e.g.: auto, manual, bracketting...
	QString AFPointNum;		// number AF points
	QString AFPointSel;		// AF points selected
	QString faceDetect;		// face detected
	QString imgStabi;		// image stabilization
	QString AEBValue;		// AEB value, relative to center value, at least for Canon 40D
	QString lensAperture;	// lens aperture or aperture range
	QString camISO;			// more cam set - camera ISO setting
};


#endif  // _STRUCTS_H_

